/* Copyright 2003-2005 Wang, Chun-Pin All rights reserved. */
#ifndef	_SMBFTPD_PARAM_H_
#define _SMBFTPD_PARAM_H_

#include <sys/stat.h>
#include <netdb.h>
#include "smbftpd.h"

#define	MODE_NORMAL	0
#define	MODE_SMB	1

typedef	enum OPT_TYPE {
	OPT_TYPE_UNKNOWN = 0,
	OPT_TYPE_INT = 1,
	OPT_TYPE_OCTAL,
	OPT_TYPE_STR,
	OPT_TYPE_SET,
	OPT_TYPE_YES_NO,
	OPT_TYPE_MODE,
	OPT_TYPE_PATH
} OPT_TYPE;

/* List of all option in config file */
typedef struct CONF_OPT_LIST {
	char *szOptString;
	OPT_TYPE OptType;
	void *SysConfMember;
} CONF_OPT_LIST;

struct OPT_SET {
	struct OPT_SET *next;
	char *szKey;
	char *szValue;
};

/* system config read from config file */
typedef struct SYS_CONF {
	struct OPT_SET *ChrootSet;
	struct OPT_SET *MaxDownloadRate;
	struct OPT_SET *MaxUploadRate;
	char *szServerName;
	char *szListenOnAddress;
	char *szPort;
	char *szShareConf;
	char *szExceptionList;
	char *szPidFile;
	char *szTransferLog;
	char *szNoLoginList;
	char *szSecurityPolicy;
	char *szEncryptionType;
	char *szSSLCertFile;
	char *szSSLKeyFile;
	char *szSSLDebugLog;
	int NormalUserMustSecure;
	int AnonymDisableSecure;
	int SSLDebugMode;
	int DefaultMode;
	int DebugMode;
	int LogCommand;
	int DoWtmpLog;
	int RequireValidShell;
	int RestrictedPorts;
	int RestrictedDataPorts;
	int AnonymousLogin;
	int AnonymousOnly;
	int EmptyPasswdLogin;
	int ShowSymlinks;
	int DisableEPSV;
	int Umask;
	int MaxConnection;
	int TimeOut;
	int MaxTimeOut;
} SYS_CONF;

typedef	struct SESSION {
	struct SHARE_SET *pValidShare;
	struct passwd *pwUser;
	int DoChroot;
	char *szHomeDir;
	char szRemoteHost[NI_MAXHOST];
	int DefaultMode;
	off_t MaxUploadRate;
	off_t MaxDownloadRate;
	off_t ByteUpload;
	off_t ByteDownload;
} SESSION;

int ConfigParse(char *szConfig);
void ConfigRelease(void);
void ConfigDefSet(void);

#endif /* _SMBFTPD_PARAP_H */
