/* Copyright 2003-2005 Wang, Chun-Pin All rights reserved. */
#ifndef	_SMBFTPD_SMBFTPD_H_
#define	_SMBFTPD_SMBFTPD_H_

#include <limits.h>
#include <sys/param.h>
#include "config.h"
#include <misc.h>
/* Used in share's attribute */
#define	ATTRIB_NO_BROWSE    0x0001
#define	ATTRIB_NO_DOWNLOAD  0x0002
#define	ATTRIB_NO_LIST      0x0004
#define	ATTRIB_NO_MODIFY    0x0008
#define	ATTRIB_WRITABLE	    0x0010

/* Used in SzGetRealPath()'s flag */
#define	FLAG_CHECK_WRITABLE	0x0001
#define	FLAG_NO_FOLLOW_LINK	0x0002
#define FLAG_NO_FOLLOW_LAST_LINK	0x0004 /* For rename */

/* struct to save share's information */
struct SMB_SHARE {
	struct SMB_SHARE *pNext;
	char *szShare;
	char *szPath;
	char *szRW;
	char *szRO;
	char *szDisableRETR;
	char *szDisableLIST;
	char *szDisableModify;
	int flags;
};

/* struct to save share's path and flags */
struct SHARE_SET {
	struct SHARE_SET *pNext;
	char *szShare;
	char *szPath;
	int flags;
} SHARE_SET;

/* smbftpd.c */
BOOL CheckShareFlag(struct SHARE_SET *pValidShare, char *szPath, int ShareFlags);
int ValidShareGet(char *szUser, struct SMB_SHARE *pSmbShare, struct SHARE_SET **ppValidShare);
void ValidShareFree(struct SHARE_SET **ppValidShare);
int SmbReplaceSharePath(struct SHARE_SET *ValidhShare, char *szPath, int BufSize);
char *SzGetRealPath(struct SHARE_SET *pValidShare, char *szPath, int CheckWritable);
int SMBShareEnum(char *szfSmbConf, struct SMB_SHARE **ppSmbShare);
void SMBShareFree(struct SMB_SHARE **ppSmbShare);

#ifndef	HAVE_PWCACHE
char *user_from_uid(uid_t uid, int nouser);
char *group_from_gid(gid_t gid, int nogroup);
#endif

#endif /* _SMBFTPD_SMBFTPD_H_ */
